searchData={"items":[{"type":"module","title":"dns","doc":"The `dns` module is the primary entry point for the functionality in this library.\nThe module exports various types used in type specs, such as `t:message/0`, which indicates\na `#dns_message{}` record, `t:query/0` which represents a single `#dns_query{}` record,\n`t:questions/0`, which represents a list of queries, etc.\n\nIt also exports functions for encoding and decoding messages,\nTSIG supporting functions, and various utility functions for comparing domain names, converting\ndomain names into different cases, converting to and from label lists, etc.","ref":"dns.html"},{"type":"function","title":"dns.add_tsig/5","doc":"","ref":"dns.html#add_tsig/5"},{"type":"function","title":"dns.add_tsig/6","doc":"","ref":"dns.html#add_tsig/6"},{"type":"function","title":"dns.alg_name/1","doc":"","ref":"dns.html#alg_name/1"},{"type":"function","title":"dns.class_name/1","doc":"","ref":"dns.html#class_name/1"},{"type":"function","title":"dns.compare_dname/2","doc":"","ref":"dns.html#compare_dname/2"},{"type":"function","title":"dns.const_compare/2","doc":"","ref":"dns.html#const_compare/2"},{"type":"function","title":"dns.decode_message/1","doc":"","ref":"dns.html#decode_message/1"},{"type":"function","title":"dns.decode_rrdata/3","doc":"","ref":"dns.html#decode_rrdata/3"},{"type":"function","title":"dns.dname_to_labels/1","doc":"","ref":"dns.html#dname_to_labels/1"},{"type":"function","title":"dns.dname_to_lower/1","doc":"","ref":"dns.html#dname_to_lower/1"},{"type":"function","title":"dns.dname_to_upper/1","doc":"","ref":"dns.html#dname_to_upper/1"},{"type":"function","title":"dns.encode_dname/1","doc":"","ref":"dns.html#encode_dname/1"},{"type":"function","title":"dns.encode_message/1","doc":"","ref":"dns.html#encode_message/1"},{"type":"function","title":"dns.encode_message/2","doc":"","ref":"dns.html#encode_message/2"},{"type":"function","title":"dns.encode_rrdata/2","doc":"","ref":"dns.html#encode_rrdata/2"},{"type":"function","title":"dns.eoptcode_name/1","doc":"","ref":"dns.html#eoptcode_name/1"},{"type":"function","title":"dns.ercode_name/1","doc":"","ref":"dns.html#ercode_name/1"},{"type":"function","title":"dns.escape_label/1","doc":"","ref":"dns.html#escape_label/1"},{"type":"function","title":"dns.labels_to_dname/1","doc":"","ref":"dns.html#labels_to_dname/1"},{"type":"function","title":"dns.llqerrcode_name/1","doc":"","ref":"dns.html#llqerrcode_name/1"},{"type":"function","title":"dns.llqopcode_name/1","doc":"","ref":"dns.html#llqopcode_name/1"},{"type":"function","title":"dns.opcode_name/1","doc":"","ref":"dns.html#opcode_name/1"},{"type":"function","title":"dns.random_id/0","doc":"","ref":"dns.html#random_id/0"},{"type":"function","title":"dns.rcode_name/1","doc":"","ref":"dns.html#rcode_name/1"},{"type":"function","title":"dns.tsigerr_name/1","doc":"","ref":"dns.html#tsigerr_name/1"},{"type":"function","title":"dns.type_name/1","doc":"","ref":"dns.html#type_name/1"},{"type":"function","title":"dns.unix_time/0","doc":"","ref":"dns.html#unix_time/0"},{"type":"function","title":"dns.unix_time/1","doc":"","ref":"dns.html#unix_time/1"},{"type":"function","title":"dns.verify_tsig/3","doc":"","ref":"dns.html#verify_tsig/3"},{"type":"function","title":"dns.verify_tsig/4","doc":"","ref":"dns.html#verify_tsig/4"},{"type":"type","title":"dns.additional/0","doc":"","ref":"dns.html#t:additional/0"},{"type":"type","title":"dns.alg/0","doc":"","ref":"dns.html#t:alg/0"},{"type":"type","title":"dns.answers/0","doc":"","ref":"dns.html#t:answers/0"},{"type":"type","title":"dns.authority/0","doc":"","ref":"dns.html#t:authority/0"},{"type":"type","title":"dns.class/0","doc":"","ref":"dns.html#t:class/0"},{"type":"opaque","title":"dns.compmap/0","doc":"","ref":"dns.html#t:compmap/0"},{"type":"type","title":"dns.decode_error/0","doc":"","ref":"dns.html#t:decode_error/0"},{"type":"type","title":"dns.dname/0","doc":"","ref":"dns.html#t:dname/0"},{"type":"type","title":"dns.encode_message_opt/0","doc":"","ref":"dns.html#t:encode_message_opt/0"},{"type":"type","title":"dns.encode_message_tsig_opt/0","doc":"","ref":"dns.html#t:encode_message_tsig_opt/0"},{"type":"type","title":"dns.eoptcode/0","doc":"","ref":"dns.html#t:eoptcode/0"},{"type":"type","title":"dns.ercode/0","doc":"","ref":"dns.html#t:ercode/0"},{"type":"type","title":"dns.label/0","doc":"","ref":"dns.html#t:label/0"},{"type":"type","title":"dns.llqerrcode/0","doc":"","ref":"dns.html#t:llqerrcode/0"},{"type":"type","title":"dns.llqopcode/0","doc":"","ref":"dns.html#t:llqopcode/0"},{"type":"type","title":"dns.message/0","doc":"","ref":"dns.html#t:message/0"},{"type":"type","title":"dns.message_bin/0","doc":"","ref":"dns.html#t:message_bin/0"},{"type":"type","title":"dns.message_id/0","doc":"","ref":"dns.html#t:message_id/0"},{"type":"type","title":"dns.opcode/0","doc":"","ref":"dns.html#t:opcode/0"},{"type":"type","title":"dns.opt_ecs/0","doc":"","ref":"dns.html#t:opt_ecs/0"},{"type":"type","title":"dns.opt_llq/0","doc":"","ref":"dns.html#t:opt_llq/0"},{"type":"type","title":"dns.opt_nsid/0","doc":"","ref":"dns.html#t:opt_nsid/0"},{"type":"type","title":"dns.opt_owner/0","doc":"","ref":"dns.html#t:opt_owner/0"},{"type":"type","title":"dns.opt_ul/0","doc":"","ref":"dns.html#t:opt_ul/0"},{"type":"type","title":"dns.opt_unknown/0","doc":"","ref":"dns.html#t:opt_unknown/0"},{"type":"type","title":"dns.optrr/0","doc":"","ref":"dns.html#t:optrr/0"},{"type":"type","title":"dns.optrr_elem/0","doc":"","ref":"dns.html#t:optrr_elem/0"},{"type":"type","title":"dns.query/0","doc":"","ref":"dns.html#t:query/0"},{"type":"type","title":"dns.questions/0","doc":"","ref":"dns.html#t:questions/0"},{"type":"type","title":"dns.rcode/0","doc":"","ref":"dns.html#t:rcode/0"},{"type":"type","title":"dns.rr/0","doc":"","ref":"dns.html#t:rr/0"},{"type":"type","title":"dns.rrdata/0","doc":"","ref":"dns.html#t:rrdata/0"},{"type":"type","title":"dns.rrdata_rrsig/0","doc":"","ref":"dns.html#t:rrdata_rrsig/0"},{"type":"type","title":"dns.svcb_svc_params/0","doc":"","ref":"dns.html#t:svcb_svc_params/0"},{"type":"type","title":"dns.tsig_alg/0","doc":"","ref":"dns.html#t:tsig_alg/0"},{"type":"type","title":"dns.tsig_error/0","doc":"","ref":"dns.html#t:tsig_error/0"},{"type":"type","title":"dns.tsig_mac/0","doc":"","ref":"dns.html#t:tsig_mac/0"},{"type":"type","title":"dns.tsig_opt/0","doc":"","ref":"dns.html#t:tsig_opt/0"},{"type":"type","title":"dns.ttl/0","doc":"","ref":"dns.html#t:ttl/0"},{"type":"type","title":"dns.type/0","doc":"","ref":"dns.html#t:type/0"},{"type":"type","title":"dns.uint2/0","doc":"","ref":"dns.html#t:uint2/0"},{"type":"type","title":"dns.uint4/0","doc":"","ref":"dns.html#t:uint4/0"},{"type":"type","title":"dns.uint8/0","doc":"","ref":"dns.html#t:uint8/0"},{"type":"type","title":"dns.uint16/0","doc":"","ref":"dns.html#t:uint16/0"},{"type":"type","title":"dns.uint32/0","doc":"","ref":"dns.html#t:uint32/0"},{"type":"type","title":"dns.uint48/0","doc":"","ref":"dns.html#t:uint48/0"},{"type":"type","title":"dns.uint64/0","doc":"","ref":"dns.html#t:uint64/0"},{"type":"type","title":"dns.unix_time/0","doc":"","ref":"dns.html#t:unix_time/0"},{"type":"module","title":"dns_record","doc":"The `dns_record` module exports `serialise` and `deserialise` functions\nfor serialising and deserialising messages.\n\nYou will generally not use these functions directly, rather you will use\nthe functions for encoding and decoding messages exported by `m:dns`.","ref":"dns_record.html"},{"type":"function","title":"dns_record.deserialise/1","doc":"","ref":"dns_record.html#deserialise/1"},{"type":"function","title":"dns_record.deserialise/2","doc":"","ref":"dns_record.html#deserialise/2"},{"type":"function","title":"dns_record.serialise/1","doc":"","ref":"dns_record.html#serialise/1"},{"type":"function","title":"dns_record.serialise/2","doc":"","ref":"dns_record.html#serialise/2"},{"type":"module","title":"dns_record_info","doc":"This module exports utility functions used to inspect records.\nYou will generally not use these functions directly.","ref":"dns_record_info.html"},{"type":"function","title":"dns_record_info.atom_for_type/1","doc":"","ref":"dns_record_info.html#atom_for_type/1"},{"type":"function","title":"dns_record_info.fields/1","doc":"","ref":"dns_record_info.html#fields/1"},{"type":"function","title":"dns_record_info.size/1","doc":"","ref":"dns_record_info.html#size/1"},{"type":"function","title":"dns_record_info.type_for_atom/1","doc":"","ref":"dns_record_info.html#type_for_atom/1"},{"type":"module","title":"dnssec","doc":"The `dnssec` module exports functions used for generating NSEC responses,\nsigning and verifying RRSIGs, and adding keytags to DNSKEY records.\n\nFor example, the `sign_rr/6` function can be given a collection of resource records,\nthe signer name, keytag, signing algorithm, private key, and a collection of options\nand it will return a list of RRSIG records. Currently only DSA and RSA algorithms are\nsupported for signing RRSETs.","ref":"dnssec.html"},{"type":"function","title":"dnssec.add_keytag_to_cdnskey/1","doc":"","ref":"dnssec.html#add_keytag_to_cdnskey/1"},{"type":"function","title":"dnssec.add_keytag_to_dnskey/1","doc":"","ref":"dnssec.html#add_keytag_to_dnskey/1"},{"type":"function","title":"dnssec.canonical_rrdata_form/1","doc":"","ref":"dnssec.html#canonical_rrdata_form/1"},{"type":"function","title":"dnssec.gen_nsec3/1","doc":"","ref":"dnssec.html#gen_nsec3/1"},{"type":"function","title":"dnssec.gen_nsec3/6","doc":"","ref":"dnssec.html#gen_nsec3/6"},{"type":"function","title":"dnssec.gen_nsec3/7","doc":"","ref":"dnssec.html#gen_nsec3/7"},{"type":"function","title":"dnssec.gen_nsec/1","doc":"","ref":"dnssec.html#gen_nsec/1"},{"type":"function","title":"dnssec.gen_nsec/3","doc":"","ref":"dnssec.html#gen_nsec/3"},{"type":"function","title":"dnssec.gen_nsec/4","doc":"","ref":"dnssec.html#gen_nsec/4"},{"type":"function","title":"dnssec.ih/4","doc":"","ref":"dnssec.html#ih/4"},{"type":"function","title":"dnssec.sign_rr/5","doc":"","ref":"dnssec.html#sign_rr/5"},{"type":"function","title":"dnssec.sign_rr/6","doc":"","ref":"dnssec.html#sign_rr/6"},{"type":"function","title":"dnssec.sign_rrset/5","doc":"","ref":"dnssec.html#sign_rrset/5"},{"type":"function","title":"dnssec.sign_rrset/6","doc":"","ref":"dnssec.html#sign_rrset/6"},{"type":"function","title":"dnssec.verify_rrsig/4","doc":"","ref":"dnssec.html#verify_rrsig/4"},{"type":"type","title":"dnssec.gen_nsec_opt/0","doc":"","ref":"dnssec.html#t:gen_nsec_opt/0"},{"type":"type","title":"dnssec.key/0","doc":"","ref":"dnssec.html#t:key/0"},{"type":"type","title":"dnssec.keytag/0","doc":"","ref":"dnssec.html#t:keytag/0"},{"type":"type","title":"dnssec.nsec3_hashalg/0","doc":"","ref":"dnssec.html#t:nsec3_hashalg/0"},{"type":"type","title":"dnssec.nsec3_hashalg_fun/0","doc":"","ref":"dnssec.html#t:nsec3_hashalg_fun/0"},{"type":"type","title":"dnssec.nsec3_iterations/0","doc":"","ref":"dnssec.html#t:nsec3_iterations/0"},{"type":"type","title":"dnssec.nsec3_salt/0","doc":"","ref":"dnssec.html#t:nsec3_salt/0"},{"type":"type","title":"dnssec.sigalg/0","doc":"","ref":"dnssec.html#t:sigalg/0"},{"type":"type","title":"dnssec.sign_rr_opt/0","doc":"","ref":"dnssec.html#t:sign_rr_opt/0"},{"type":"type","title":"dnssec.verify_rrsig_opt/0","doc":"","ref":"dnssec.html#t:verify_rrsig_opt/0"},{"type":"extras","title":"Overview","doc":"# dns\\_erlang\n\nAn Erlang DNS message library that supports most common record types, TSIG authenticated messages, EDNS0 and DNSSEC.\n\n[![Build Status](https://github.com/dnsimple/dns_erlang/actions/workflows/ci.yml/badge.svg)](https://github.com/dnsimple/dns-erlang/actions/workflows/ci.yml)\n[![Module Version](https://img.shields.io/hexpm/v/dns_erlang.svg)](https://hex.pm/packages/dns_erlang)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/dns_erlang/)\n[![Hex Downloads](https://img.shields.io/hexpm/dt/dns_erlang.svg)](https://hex.pm/packages/dns_erlang)\n[![Coverage Status](https://coveralls.io/repos/github/dnsimple/dns_erlang/badge.svg?branch=main)](https://coveralls.io/github/dnsimple/dns_erlang?branch=main)","ref":"readme.html"},{"type":"extras","title":"Usage - Overview","doc":"This library exposes types via `include/dns.hrl`, which in turn includes `include/dns_terms.hrl` and `include/dns_records.hrl`, as well as functions useful for constructing and deconstructing DNS packets with `src/dns.erl`\n\nThis is a library, not a DNS server. It is meant to be used by Erlang-based DNS servers for low level packet handling and RR processing.\n\nIf you'd like to see a full example of `dns_erlang` in use, please have a look at [erldns](https://github.com/dnsimple/erldns).","ref":"readme.html#usage"},{"type":"extras","title":"Details - Overview","doc":"The following section explains what is contained in the library in greater detail.\n\nFor more details, see [Hex Docs](https://hexdocs.pm/dns_erlang/).","ref":"readme.html#details"},{"type":"extras","title":"dns\\_terms.hrl - Overview","doc":"This file defines various terms, defined as Erlang macros, that are used in DNS packets. It includes a term for each DNS type, including one term for the numeric value and one term for the binary version. For example:\n\n```erlang\n-define(DNS_TYPE_A_NUMBER, 1).\n-define(DNS_TYPE_A_BSTR, <<\"A\">>).\n-define(DNS_TYPE_NS, ?DNS_TYPE_NS_NUMBER).\n```\n\nIt also contains rcodes, opcodes, errcodes, etc.","ref":"readme.html#dns-_terms-hrl"},{"type":"extras","title":"dns\\_records.hrl - Overview","doc":"This file defines the record definitions for various Erlang record types that are useful for representing DNS constructs. For example, the `dns_message` record represents all of the elements that you would find in a single DNS message.\n\n```erlang\n-record(dns_message, {id = dns:random_id() :: dns:message_id(),\n\t\t      qr = false :: 0..1 | boolean(),\n\t\t      oc = ?DNS_OPCODE_QUERY :: dns:opcode(),\n\t\t      aa = false :: 0..1 | boolean(),\n\t\t      tc = false :: 0..1 | boolean(),\n\t\t      rd = false :: 0..1 | boolean(),\n\t\t      ra = false :: 0..1 | boolean(),\n\t\t      ad = false :: 0..1 | boolean(),\n\t\t      cd = false :: 0..1 | boolean(),\n\t\t      rc = ?DNS_RCODE_NOERROR :: dns:rcode(),\n\t\t      qc = 0 :: 0..65535,\n\t\t      anc = 0 :: 0..65535,\n\t\t      auc = 0 :: 0..65535,\n\t\t      adc = 0 :: 0..65535,\n\t\t      questions = [] :: dns:questions(),\n\t\t      answers = [] :: dns:answers(),\n\t\t      authority = [] :: dns:authority(),\n\t\t      additional = [] :: dns:additional()}).\n```\n\nEach of the record fields in `dns_message` corresponds to the elements defined in section 4 of [RFC 1035](https://tools.ietf.org/html/rfc1035). For example, `id` corresponds to the message header field `ID`, which is defined as:\n\n> A 16 bit identifier assigned by the program that generates any kind of query.  This identifier is copied the corresponding reply and can be used by the requester to match up replies to outstanding queries.\n\nOther records defined include `dns_query`, which represents a single question in the `#dns_message.questions` field, `dns_rr` which corresponds to a single resource record (RR), which appears in the `answers`, `authority`, `additional` section of the `dns_message`, and so on.\n\nNote that all support RR types must include a `dns_rrdata_` record definition, used to store the parts of the RDATA for that RR type.","ref":"readme.html#dns-_records-hrl"},{"type":"extras","title":"License","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS","ref":"license.html"}],"proglang":"erlang","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}